import java.rmi.*;
import java.rmi.server.*;

class BankAccount extends MigratableRemote implements Account
{
	public String name;
	public Integer no;
	public double balance;

	public BankAccount() throws RemoteException{
		name = new String();
	}

	public BankAccount(String name, int no, double balance) throws RemoteException{
		this.name = new String(name);
		this.no = new Integer(no);
		this.balance = balance;
	}

	public String getAccountName() throws RemoteException {
		System.out.println("Name is " + name);
		return name;
	}

	public void setBalance(double value) throws RemoteException {
		balance = value;
	}

	public double getBalance() throws RemoteException {
		System.out.println("Balance is " + balance);
		return balance;
	}

	public static void main(String[] args) 
	{
		/** 
		 * Get the server & port info from the command line.
		 * Or use the InetAddress class to get local host address
		 */
		String serverPort = args[0]; 

		try{
		  System.out.println("Constructing server implementation ...");

		  /**
		   * You can initialise the BankAccount object accordingly
		   */
		  BankAccount acc1 = new BankAccount("Nauzad", 1234, 1000);
		  System.out.println("Binding server Implementations to registry ....");
		  Naming.rebind(serverPort+"Account",acc1);
		  System.out.println("Waiting for invocations from clients ...");
		}
		catch (Exception e){
		  System.out.println("Error: "+e);
		}
	}
}